config/routes.rb
Rails.application.routes.draw do

 root :to => 'pages#front'
  
 get 'ui(/:action)', controller: 'ui'
 
 get '/ruby-version' => 'application#ruby_version'

 resources :funds, except: [:destroy]
 resources :patrons, except: [:destroy]
 
 resources :recharges do
   collection do
     get 'search', to: 'recharges#search'
     get 'process_batch', to: 'recharges#process_batch'
     get 'create_output', to: 'recharges#create_output'
     get 'ftp_file', to: 'recharges#ftp_file'
   end 
 end

 resources :invoices do
   collection do
     get 'search', to: 'invoices#search'
     get 'process_batch', to: 'invoices#process_batch'
     get 'create_charge_output', to: 'invoices#create_charge_output'
     get 'create_person_output', to: 'invoices#create_person_output'
     get 'create_entity_output', to: 'invoices#create_entity_output'
     get 'ftp_file', to: 'invoices#ftp_file'
     get 'create_report', to: 'invoices#create_report'
     get 'merge_records', to: 'invoices#merge_records'
   end
 end

 get '/invoices/:id/create_bill', to: 'invoices#create_bill', as: :create_bill_invoice

 get "/signin", to: 'sessions#new', as: :signin
 get "/auth/shibboleth", as: :shibboleth
 get "/auth/developer", to: 'sessions#developer', as: :developer
 match "/auth/shibboleth/callback" => "sessions#shibboleth", as: :callback, via: [:get, :post]
 match "/signout" => "sessions#destroy", as: :signout, via: [:get, :post]
end

app/views/shared/_content_title.html.haml
%header
  %h1 
    = title
%p.required
  * Required field

app/views/shared/_error_messages.html.haml
- if obj.errors.any? 
  #error_explanation
    %h2
      = pluralize(obj.errors.count, "error") 
      prohibited this record from being saved.

      
    

app/views/shared/_footer.html.haml
%section
  #footer
    .container.footer-container
      %address
        %strong UC San Diego
        9500 Gilman Dr.
        La Jolla, CA 92093
        (858) 534-2230
      %p Copyright © 2013 Regents of the University of California. All rights reserved.
      %ul.inline
        %li
          %a{:href => "http://www.ucsd.edu/_about/legal/index.html"} Terms & Conditions
        %li.muted
        %li= link_to '| Feedback'
        %li.muted
        %li
          %a{:href => "http://libraries.ucsd.edu/"} | Library Home

app/views/shared/_header.html.haml
%section#top-header
  %nav.navbar.navbar-inverse.navbar-inner.navbar-static-top{:role => "navigation"}
    .navbar-header
      %button.navbar-toggle{"data-target" => "#bs-example-navbar-collapse-1", "data-toggle" => "collapse", :type => "button"}
        %span.sr-only Toggle navigation
        %span.icon-bar
        %span.icon-bar
        %span.icon-bar
      %a.navbar-brand{:href => "#"} Ill Billing
    / Collect the nav links, forms, and other content for toggling
    #bs-example-navbar-collapse-1.collapse.navbar-collapse
      - if logged_in?
        %ul.nav.navbar-nav
          %li= link_to "Home", root_path
          %li.dropdown
            %a.dropdown-toggle{"data-toggle" => "dropdown", :href => "#"}
              Recharge
              %b.caret
            %ul.dropdown-menu#dropdown-text
              %li
                =link_to "Create new Recharge", new_recharge_path
              %li
                =link_to "View or process current batch", process_batch_recharges_path
              %li
                =link_to "View all Recharges", recharges_path
          %li.dropdown
            %a.dropdown-toggle{"data-toggle" => "dropdown", :href => "#"}
              Invoice
              %b.caret
            %ul.dropdown-menu#dropdown-text
              %li
                =link_to "Create new Invoice", new_invoice_path
              %li
                =link_to "View or process current batch", process_batch_invoices_path
              %li
                =link_to "View all Invoices", invoices_path
          %li.dropdown
            %a.dropdown-toggle{"data-toggle" => "dropdown", :href => "#"}
              Patron
              %b.caret
            %ul.dropdown-menu#dropdown-text
              %li
                =link_to "Create new Patron", new_patron_path
              %li
                =link_to "View all Patrons", patrons_path
          %li.dropdown
            %a.dropdown-toggle{"data-toggle" => "dropdown", :href => "#"}
              Funds
              %b.caret
            %ul.dropdown-menu#dropdown-text
              %li
                =link_to "Create new Fund", new_fund_path
              %li
                =link_to "View all Funds", funds_path
        %ul.nav.navbar-nav.navbar-right
          .navbar-form.navbar-left{:role => "search"}
            = form_tag search_invoices_path, method: "GET", id: "myForm", role: "search" do
              .form-group
              .input-group.search-bar-input-group
                %input.form-control.search-bar{:name => "search_term", :placeholder => "Default search invoice by number", :type => "text"}
                  %span.input-group-btn
                    %button.btn.btn-default.search-bar-btn{:type => "submit"}
                      %span.glyphicon.glyphicon-search.right2{"aria-hidden" => "true"}
          %li.dropdown
            %a.dropdown-toggle{"data-toggle" => "dropdown", :href => "#"}
              Welcome, #{current_user.full_name}
              %b.caret
            %ul.dropdown-menu#dropdown-text
              %li
                =link_to "Sign out", signout_path
            
          
      

app/views/shared/_messages.html.haml
- flash.each do |name, msg|
  %div(class="alert alert-#{name} alert-success")
    %a.close(data-dismiss='alert') &#215;
    = content_tag :div, sanitize(msg), :id => "flash_#{name}" if msg.is_a?(String)

app/views/shared/_modal.html.haml
/ Modal
.modal.fade{"aria-hidden" => "true", "aria-labelledby" => "ftp-label", :id => "ftp-notes", :role => "dialog", :tabindex => "-1"}
  .modal-dialog
    .modal-content
      .modal-header
        %h4.modal-title{:id => "ftp-label"} UCSD ILL BILLING
      .modal-body
        = sanitize(msg_body)
      .modal-footer
        %button.btn.btn-primary{"data-dismiss" => "modal", :type => "button"} No
        = link_to "Yes", target_url, method: :get, class: 'btn btn-primary'
         

app/views/shared/_modal_merge.html.haml
/ Modal
.modal.fade{"aria-hidden" => "true", "aria-labelledby" => "merge-label", :id => "merge-notes", :role => "dialog", :tabindex => "-1"}
  .modal-dialog
    .modal-content
      .modal-header
        %h4.modal-title{:id => "merge-label"} UCSD ILL BILLING
      .modal-body
        = sanitize(msg_body)
      .modal-footer
        %button.btn.btn-primary{"data-dismiss" => "modal", :type => "button"} No
        = link_to "Yes", target_url, method: :get, class: 'btn btn-primary'